<?php

namespace plugin\inspection\controller\api;

use plugin\inspection\model\InspectionStaff;
use plugin\inspection\model\InspectionStaffToken;
use think\admin\Controller;
use think\admin\model\SystemUser;
use think\exception\HttpResponseException;

class Auth extends Controller
{
    /** @var InspectionStaff 检修员工 */
    protected $staff;
    protected $tokenInfo;
    public function initialize()
    {
        parent::initialize();
        try {
            // 获取请求令牌内容
            // 优先识别 Bearer Token 机制，再识别 api-token 字段
            $token = $this->request->header('Authorization', '');
            if (!empty($token) && stripos($token, 'Bearer ') === 0) {
                $token = substr($token, 7);
            }
            if (empty($token)) {
                $token = $this->request->header('api-token', '');
            }
            if (empty($token)) $this->error('需要登录授权', [], 401);
            // 读取用户账号数据
            $tokenInfo = InspectionStaffToken::query()->where('token', "=", $token)->find();
            if (empty($tokenInfo)) {
                $this->error('无效的登录令牌', [], 401);
            }
            $this->tokenInfo = $tokenInfo;
            if ($tokenInfo->is_admin != 1) {
                $this->staff = $tokenInfo->staff;
                if (!$this->staff || $this->staff->isEmpty()) {
                    $this->error('无效的登录令牌', [], 401);
                }
            } else {
                $this->user = SystemUser::query()->findOrEmpty($tokenInfo->staff_id);
                if ($this->user->isEmpty()) {
                    $this->error('无效的登录令牌', [], 401);
                }
            }
        } catch (HttpResponseException $exception) {
            throw $exception;
        } catch (\Exception $exception) {
            $this->error($exception->getMessage(), [], $exception->getCode());
        }
    }

}