<?php

namespace plugin\ticket\model;

use think\admin\Model;

class ApprovalProcess extends Model
{
    // 表名定义
    protected $name = 'approval_process';

    // 自动写入时间戳
    protected $autoWriteTimestamp = 'datetime';
    protected $createTime = 'create_time';
    protected $updateTime = 'update_time';

    // 关联审批实例
    public function instances()
    {
        return $this->hasMany(ApprovalInstance::class, 'process_id', 'id');
    }

    // 过滤有效流程
    public function scopeAvail($query)
    {
        return $query->where('status', 1);
    }

    // 流程步骤解析
    public function getStepsAttr($value)
    {
        return json_decode($value, true);
    }
}