<?php

namespace plugin\ticket\model;

use think\admin\Model;
use think\admin\model\SystemUser;

class ApprovalStep extends Model
{
    // 表名定义
    protected $name = 'approval_step';

    // 自动写入时间戳
    protected $autoWriteTimestamp = 'datetime';
    protected $createTime = 'create_time';
    protected $updateTime = 'update_time';

    // 关联审批实例
    public function instance()
    {
        return $this->belongsTo(ApprovalInstance::class, 'instance_id', 'id');
    }

    // 关联审批人（示例：关联现有用户表）
    public function approver()
    {
        return $this->belongsTo(SystemUser::class, 'approver_id', 'id');
    }

    // 格式化审批类型
    public function getApproverTypeTextAttr($value, $data)
    {
        $typeMap = [
            0 => '固定用户',
            3 => '指定用户',
//            1 => '指定部门',
//            2 => '角色审批'
        ];
        return $typeMap[$data['approver_type']] ?? '未知';
    }

    // 校验步骤有效性
    public function scopeAvail($query)
    {
        return $query->where('status', 0);
    }
}